/* Simple LED Task Handling */

/* Standard includes. */
#include <stdlib.h>

/* Scheduler includes. */
#include "FreeRTOS.h"
#include "task.h"

#define TASK_PRIORITY1			(tskIDLE_PRIORITY + 1)

xTaskHandle xLedHandle;		     //handle to the created led task

static void LED(void *pvParameters);

void Init_hardware(void);
void wait (void);

void wait (void)  {                        /* wait function */
  int  d;

  for (d = 0; d < 1000000; d++);           /* only to delay for LED flashes */
}

int main(void)
{
	Init_hardware();
	xTaskCreate(LED, "LED",configMINIMAL_STACK_SIZE, NULL,TASK_PRIORITY1,&xLedHandle);
    vTaskStartScheduler();

}

void Init_hardware()
{
  IODIR1 = 0x00FF0000;                     /* P1.16..23 defined as Outputs */ 
}
static void LED(void *pvParameters)
{
  unsigned int i;                          /* LED var */

  while (1)  {                             /* Loop forever */
    for (i = 1<<16; i < 1<<23; i <<= 1) {  /* Blink LED 0,1,2,3,4,5,6 */
      IOSET1 = i;                          /* Turn on LED */
      wait ();                             /* call wait function */
      IOCLR1 = i;                          /* Turn off LED */
    }

//    for (i = 1<<23; i > 1<<16; i >>=1 ) {  /* Blink LED 7,6,5,4,3,2,1 */
//      IOSET1 = i;                          /* Turn on LED */
//      wait ();                             /* call wait function */
//      IOCLR1 = i;                          /* Turn off LED */
//    }

  }
}
